# Transfer's notes

<b>Author</b>: SolidCinder7914<br>
<b>Category</b>: Crypto<br>
<b>Solve</b>: 9<br>

## Descritpion
Someone said that this application would ensure the safety of all the noted transactions...

## How to run the server
To run the server you'll need [`docker`](https://docs.docker.com/get-docker/) and [`docker-compose`](https://docs.docker.com/compose/install/).<br>
Go into the `src` folder and from the command line run `docker-compose up --build -d`.<br>
Now you can connect to the server by running `nc localhost 31343` in your terminal.<br>
To stop the server, from the command line run `docker-compose down`.

## Solution

The service allowed users to save notes about their "transfers", storing data about the recipient, the amount transferred and providing a section for a description.

```
[user] Available operations:
1) List users
2) List transactions
3) List my transactions
4) New transaction
5) List transactions by user
6) Exit
```

Each user or guest could then list all the "transfers" of all users as well as all the "transfers" of a single user of their choice, but each "transfer" that isn't of the currently logged in user would be shown encrypted.

```
Available operations:
1) List users
2) List transactions
3) Login
4) Register
5) List transactions by user
6) Exit
```

This passage of encryption took place as described in the file `utils.py` (rows from 47 to 57 included):

```python
class UserChannel:
    ...

    def encode(self, transactions: list):
        return {timestamp: self.encode_transaction(transactions[timestamp]) for timestamp in transactions}

    def encode_transaction(self, transaction: str):
        i = transaction.index(' <- ')
        t = padding(transaction[:i], 64) + ' <- '
        j = transaction.index(' | ')
        t += padding(transaction[i+4:j], 16)
        t += transaction[j:]
        t = padding(t, 128)
        return xor(t, self.__secret)

    ...
```

The output from the `encode` function would then be used and shown in the printed output: specifically, when requesting to show all the "transactions" of a chosen user.

The vulnerability lies in the way the `__secret` used to encrypt the details of each "transaction" is generated (in `utils.py`, line 38):

```python
class UserChannel:
    def __init__(self, username: str, password: str='', hashed: bytes=None) -> None:
        ...
        self.__secret = os.urandom(1)
    
    ...
```

As the key used to encrypt all the data is a single randomly generated byte, there are only 256 possible keys, thus a bruteforce is enough.

It wasn't needed to know which user stored the flag, given their number and their transactions' limited number, which allowed to just try them all, but the actual target of the attack was the user `Admin`.

Once retreived the data (by listing all of `Admin`'s transactions) with a code like the following one, it was enough to try all the possible keys and search for the flag's distinctive format:

```python
import pwn

conn = pwn.remote('tcp.challs.m0lecon.it', 8293)
conn.sendline(b'5')
conn.sendline(b'Admin')
conn.recvuntil(b'[description]\n')
ciph = conn.recvuntil(b'\n\n').decode().strip().split("\n")
conn.close()
```

Thus the bruteforce works as followed:

```python
def xor(a: bytes, b: bytes):
    n = len(b)
    return bytes([a[i] ^ b[i%n] for i in range(len(a))])

ciph = [x.split()[1] for x in ciph]
ciph = bytes.fromhex("".join(ciph))

for x in range(256):
    r = xor(ciph, bytes([x]))
    if b'ptm' in r:
        i = r.index(b'ptm')
        j = i + r[i:].index(b'}') + 1
        print(r[i:j].decode())
        break
```
